
#include <stdio.h>
#include "linda3.h"
/* ----------------------------------------------
** Ce programme calcule en parallele toutes
** les valeurs de Cnk(n,k), pour n <= nmax
*/
int main(int argc, char *argv[])
{
    long nk[2] ,nmax, k;
    TupleType cnkresult ; 
    TupleSelector s ; 
    struct CNK { long n,k,cnk ; } tuple ;

    if( argc != 2 )
    {
    	printf("\nUsage: cnkm val_maxi\n" ) ;
    	exit(0) ;
    }
    nmax = (long)atoi(argv[1]) ;
    cnkresult = DefineTupleType("Cnk","{l l l}" ) ;
    s = CreateTupleSelector(cnkresult, "{.??}" ) ;

    /* creation des processus de calcul */
    for(nk[0] = 0 ; nk[0] <= nmax ; ++nk[0] )
    {
         for(nk[1] = 0 ; nk[1] <= nk[0] ; ++nk[1] )

          {
              Eval("CNK",    &cnkresult, 1 , 
                             nk , sizeof(nk)) ;
         }
    }

    /* retrait des tuples generes par les 
    ** processus de calcul:
    ** L'element n du tuple Est le critere d'acces
    */
    for(tuple.n = 0 ; tuple.n <= nmax ; ++tuple.n )
    {
         int dummy ;
         for(dummy = 0 ; dummy <= tuple.n ; ++dummy )
         {
              in(s,&tuple); 
              printf("\nCnk(%ld,%ld) = %ld", 
                   tuple.n, tuple.k, tuple.cnk) ;
         }
    }

    /* tous les processus sont acheves,
    ** on peut donc detruire le type cnkresult
    */
    UndefTupleType(cnkresult) ;
    free(s) ;
    exit(0) ;
}


